From 2e5c529055a16cc5a34189d90c8b2ddc95a83cfc Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Oct 31 2020 04:08:17 +0000
Subject: [PATCH 1093/2232] Merge pull request #385 from dtolnay/string


Add asserts to protect string construction from nullptr when building with assertions
---

diff --git a/src/cxx.cc b/src/cxx.cc
index 05dc15a..a423df6 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -1,4 +1,5 @@
 #include "../include/cxx.h"
+#include <cassert>
 #include <cstring>
 #include <exception>
 #include <iostream>
@@ -65,9 +66,13 @@ static void initString(String *self, const char *s, size_t len) {
 
 String::String(const std::string &s) { initString(this, s.data(), s.length()); }
 
-String::String(const char *s) { initString(this, s, std::strlen(s)); }
+String::String(const char *s) {
+  assert(s != nullptr);
+  initString(this, s, std::strlen(s));
+}
 
 String::String(const char *s, size_t len) {
+  assert(s != nullptr || len == 0);
   initString(this,
              s == nullptr && len == 0 ? reinterpret_cast<const char *>(1) : s,
              len);
@@ -124,12 +129,16 @@ Str::Str(const std::string &s) : repr(Repr{s.data(), s.length()}) {
   initStr(this->repr);
 }
 
-Str::Str(const char *s) : repr(Repr{s, std::strlen(s)}) { initStr(this->repr); }
+Str::Str(const char *s) : repr(Repr{s, std::strlen(s)}) {
+  assert(s != nullptr);
+  initStr(this->repr);
+}
 
 Str::Str(const char *s, size_t len)
     : repr(
           Repr{s == nullptr && len == 0 ? reinterpret_cast<const char *>(1) : s,
                len}) {
+  assert(s != nullptr || len == 0);
   initStr(this->repr);
 }
 

